/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class sra extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           sra.class,
           "sra",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, REG.INFO)
               .declareParam("rt", ArgumentMode.IN, REG.INFO)
               .declareParam("sa", Type.CARD(0x5)),
           false,
           false,
           false,
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final Location sa = (Location) getArgument("sa", args);

        return new sra(rd, rt, sa);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
        instruction.class,
        "sra",
        true,
        new ParamDecls()
            .declareParam("rd", ArgumentMode.OUT, REG.INFO)
            .declareParam("rt", ArgumentMode.IN, REG.INFO)
            .declareParam("sa", Type.CARD(0x5)),
        true,
        true, 
        false
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
      final Location sa = (Location) getArgument("sa", args);

      return new instruction(
            new sra(
                rd,
                rt,
                sa
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rt;
  private final Location sa;

  public sra(IAddressingMode rd, IAddressingMode rt, Location sa)
  {
      assert REG.INFO.isSupported(rd);
      assert REG.INFO.isSupported(rt);
      assert Type.CARD(0x5).equals(sa.getType());

      this.rd = rd;
      this.rt = rt;
      this.sa = sa;
  }

  @Override
  public String syntax()
  {
      return String.format("sra %s, %s, %d", rd.syntax(), rt.syntax(), sa.load().getRawData().intValue());
  }

  @Override
  public String image()
  {
      return String.format("00000000000%s%s%s000011", rt.image(), rd.image(), sa.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      rd.access().store(DataEngine.execute(EOperatorID.R_SHIFT, rt.access().load(), DataEngine.coerce(WORD, sa.load())));
  }
}
