/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class ADD extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           ADD.class,
           "ADD",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, R.INFO)
               .declareParam("rs", ArgumentMode.IN, R.INFO)
               .declareParam("rt", ArgumentMode.IN, R.INFO),
           false,
           false,
           true);
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

        return new ADD(rd, rs, rt);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rs;
  private final IAddressingMode rt;

  public ADD(IAddressingMode rd, IAddressingMode rs, IAddressingMode rt)
  {
      assert R.INFO.isSupported(rd);
      assert R.INFO.isSupported(rs);
      assert R.INFO.isSupported(rt);

      this.rd = rd;
      this.rs = rs;
      this.rt = rt;
  }

  @Override
  public String syntax()
  {
      return String.format("ADD %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
  }

  @Override
  public String image()
  {
      return String.format("000000%s%s%s00000100000", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action()
  {
      temp.access().store(DataEngine.execute(EOperatorID.PLUS, Location.concat(rs.access(), rs.access().bitField(0x1f, 0x1f)).load(), Location.concat(rt.access(), rt.access().bitField(0x1f, 0x1f)).load()));
      if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, temp.access().bitField(0x20, 0x20).load(), temp.access().bitField(0x1f, 0x1f).load())))
      {
          exception("IntegerOverflow");
      }
      else
      {
          rd.access().store(temp.access().bitField(0x1f, 0x0).load());
      }
  }
}
